Index: GTP/trunk/Lib/Illum/shared/scripts/GTPIllumination.sln.old
===================================================================
--- GTP/trunk/Lib/Illum/shared/scripts/GTPIllumination.sln.old	(revision 1689)
+++ GTP/trunk/Lib/Illum/shared/scripts/GTPIllumination.sln.old	(revision 1689)
@@ -0,0 +1,94 @@
+Microsoft Visual Studio Solution File, Format Version 8.00
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "IllumModule", "..\..\IllumModule\IllumModule\scripts\illummodule.vcproj", "{109F610E-9B23-4D05-819E-A7F27A42AA94}"
+	ProjectSection(ProjectDependencies) = postProject
+	EndProjectSection
+EndProject
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "IllumModule_Ogre", "..\..\IllumModule\OgreIllumModule\scripts\OgreIllumModule.vcproj", "{109F610E-9B23-4D05-819E-A7F27A42AA94}"
+	ProjectSection(ProjectDependencies) = postProject
+		{109F610E-9B23-4D05-819E-A7F27A42AA94} = {109F610E-9B23-4D05-819E-A7F27A42AA94}
+	EndProjectSection
+EndProject
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "GameToolsRaytraceDemo", "..\..\..\..\App\Demos\Illum\Ogre\src\GameToolsRaytraceDemo\scripts\GameToolsRaytraceDemo.vcproj", "{09F9E809-02CF-4926-8203-2B9C02FBD916}"
+	ProjectSection(ProjectDependencies) = postProject
+		{109F610E-9B23-4D05-819E-A7F27A42AA94} = {109F610E-9B23-4D05-819E-A7F27A42AA94}
+		{109F610E-9B23-4D05-819E-A7F27A42AA94} = {109F610E-9B23-4D05-819E-A7F27A42AA94}
+	EndProjectSection
+EndProject
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "HPSDEMO", "..\..\..\..\App\Demos\Illum\Ogre\src\HierarchicalSystem\scripts\HierarchicalSystem.vcproj", "{09F9E809-02CF-4926-8203-2B9C02FBD916}"
+	ProjectSection(ProjectDependencies) = postProject
+		{109F610E-9B23-4D05-819E-A7F27A42AA94} = {109F610E-9B23-4D05-819E-A7F27A42AA94}
+		{109F610E-9B23-4D05-819E-A7F27A42AA94} = {109F610E-9B23-4D05-819E-A7F27A42AA94}
+	EndProjectSection
+EndProject
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "PRMDemo", "..\..\..\..\App\Demos\Illum\Ogre\src\PRMDemo\scripts\PRMDemo.vcproj", "{09F9E809-02CF-4926-8203-2B9C02FBD916}"
+	ProjectSection(ProjectDependencies) = postProject
+		{109F610E-9B23-4D05-819E-A7F27A42AA94} = {109F610E-9B23-4D05-819E-A7F27A42AA94}
+		{109F610E-9B23-4D05-819E-A7F27A42AA94} = {109F610E-9B23-4D05-819E-A7F27A42AA94}
+	EndProjectSection
+EndProject
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "GameToolsParticleDemo", "..\..\..\..\App\Demos\Illum\Ogre\src\GameToolsParticleDemo\scripts\GameToolsParticleDemo.vcproj", "{09F9E809-02CF-4926-8203-2B9C02FBD916}"
+	ProjectSection(ProjectDependencies) = postProject
+		{109F610E-9B23-4D05-819E-A7F27A42AA94} = {109F610E-9B23-4D05-819E-A7F27A42AA94}
+		{109F610E-9B23-4D05-819E-A7F27A42AA94} = {109F610E-9B23-4D05-819E-A7F27A42AA94}
+	EndProjectSection
+EndProject
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "CausticTest", "..\..\..\..\App\Demos\Illum\Ogre\src\CausticTest\scripts\CausticTest.vcproj", "{09F9E809-02CF-4926-8203-2B9C02FBD916}"
+	ProjectSection(ProjectDependencies) = postProject
+	EndProjectSection
+EndProject
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "DiffuseTest", "..\..\..\..\App\Demos\Illum\Ogre\src\DiffuseTest\scripts\DiffuseTest.vcproj", "{09F9E809-02CF-4926-8203-2B9C02FBD916}"
+	ProjectSection(ProjectDependencies) = postProject
+	EndProjectSection
+EndProject
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "ToneMapDemo", "..\..\..\..\App\Demos\Illum\Ogre\src\GameToolsToneMapDemo\scripts\GameToolsToneMapDemo.vcproj", "{09F9E809-02CF-4926-8203-2B9C02FBD916}"
+	ProjectSection(ProjectDependencies) = postProject
+	EndProjectSection
+EndProject
+Global
+	GlobalSection(SolutionConfiguration) = preSolution
+		Debug = Debug
+		Release = Release
+	EndGlobalSection
+	GlobalSection(ProjectConfiguration) = postSolution
+		{109F610E-9B23-4D05-819E-A7F27A42AA94}.Debug.ActiveCfg = Debug|Win32
+		{109F610E-9B23-4D05-819E-A7F27A42AA94}.Debug.Build.0 = Debug|Win32
+		{109F610E-9B23-4D05-819E-A7F27A42AA94}.Release.ActiveCfg = Release|Win32
+		{109F610E-9B23-4D05-819E-A7F27A42AA94}.Release.Build.0 = Release|Win32
+		{109F610E-9B23-4D05-819E-A7F27A42AA94}.Debug.ActiveCfg = Debug|Win32
+		{109F610E-9B23-4D05-819E-A7F27A42AA94}.Debug.Build.0 = Debug|Win32
+		{109F610E-9B23-4D05-819E-A7F27A42AA94}.Release.ActiveCfg = Release|Win32
+		{109F610E-9B23-4D05-819E-A7F27A42AA94}.Release.Build.0 = Release|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.ActiveCfg = Debug|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.Build.0 = Debug|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.ActiveCfg = Release|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.Build.0 = Release|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.ActiveCfg = Debug|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.Build.0 = Debug|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.ActiveCfg = Release|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.Build.0 = Release|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.ActiveCfg = Debug|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.Build.0 = Debug|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.ActiveCfg = Release|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.Build.0 = Release|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.ActiveCfg = Debug|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.Build.0 = Debug|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.ActiveCfg = Release|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.Build.0 = Release|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.ActiveCfg = Debug|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.Build.0 = Debug|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.ActiveCfg = Release|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.Build.0 = Release|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.ActiveCfg = Debug|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.Build.0 = Debug|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.ActiveCfg = Release|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.Build.0 = Release|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.ActiveCfg = Debug|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.Build.0 = Debug|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.ActiveCfg = Release|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.Build.0 = Release|Win32
+	EndGlobalSection
+	GlobalSection(ExtensibilityGlobals) = postSolution
+	EndGlobalSection
+	GlobalSection(ExtensibilityAddIns) = postSolution
+	EndGlobalSection
+EndGlobal
Index: GTP/trunk/Lib/Illum/shared/scripts/GTPIllumination.sln
===================================================================
--- GTP/trunk/Lib/Illum/shared/scripts/GTPIllumination.sln	(revision 1569)
+++ GTP/trunk/Lib/Illum/shared/scripts/GTPIllumination.sln	(revision 1689)
@@ -1,8 +1,7 @@
-Microsoft Visual Studio Solution File, Format Version 8.00
+Microsoft Visual Studio Solution File, Format Version 9.00
+# Visual Studio 2005
 Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "IllumModule", "..\..\IllumModule\IllumModule\scripts\illummodule.vcproj", "{109F610E-9B23-4D05-819E-A7F27A42AA94}"
-	ProjectSection(ProjectDependencies) = postProject
-	EndProjectSection
 EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "IllumModule_Ogre", "..\..\IllumModule\OgreIllumModule\scripts\OgreIllumModule.vcproj", "{109F610E-9B23-4D05-819E-A7F27A42AA94}"
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "IllumModule_Ogre", "..\..\IllumModule\OgreIllumModule\scripts\OgreIllumModule.vcproj", "{EE2B2AE5-1057-4EE9-A7BB-E59FCF1D5FFB}"
 	ProjectSection(ProjectDependencies) = postProject
 		{109F610E-9B23-4D05-819E-A7F27A42AA94} = {109F610E-9B23-4D05-819E-A7F27A42AA94}
@@ -12,83 +11,71 @@
 	ProjectSection(ProjectDependencies) = postProject
 		{109F610E-9B23-4D05-819E-A7F27A42AA94} = {109F610E-9B23-4D05-819E-A7F27A42AA94}
+		{EE2B2AE5-1057-4EE9-A7BB-E59FCF1D5FFB} = {EE2B2AE5-1057-4EE9-A7BB-E59FCF1D5FFB}
+	EndProjectSection
+EndProject
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "HPSDEMO", "..\..\..\..\App\Demos\Illum\Ogre\src\HierarchicalSystem\scripts\HierarchicalSystem.vcproj", "{550E3771-33C4-4994-B323-C2ABFB37FE9F}"
+	ProjectSection(ProjectDependencies) = postProject
+		{EE2B2AE5-1057-4EE9-A7BB-E59FCF1D5FFB} = {EE2B2AE5-1057-4EE9-A7BB-E59FCF1D5FFB}
 		{109F610E-9B23-4D05-819E-A7F27A42AA94} = {109F610E-9B23-4D05-819E-A7F27A42AA94}
 	EndProjectSection
 EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "HPSDEMO", "..\..\..\..\App\Demos\Illum\Ogre\src\HierarchicalSystem\scripts\HierarchicalSystem.vcproj", "{09F9E809-02CF-4926-8203-2B9C02FBD916}"
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "PRMDemo", "..\..\..\..\App\Demos\Illum\Ogre\src\PRMDemo\scripts\PRMDemo.vcproj", "{7AD6CB59-C8DB-40DB-B0E3-A2B750EB0284}"
 	ProjectSection(ProjectDependencies) = postProject
 		{109F610E-9B23-4D05-819E-A7F27A42AA94} = {109F610E-9B23-4D05-819E-A7F27A42AA94}
+		{EE2B2AE5-1057-4EE9-A7BB-E59FCF1D5FFB} = {EE2B2AE5-1057-4EE9-A7BB-E59FCF1D5FFB}
+	EndProjectSection
+EndProject
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "GameToolsParticleDemo", "..\..\..\..\App\Demos\Illum\Ogre\src\GameToolsParticleDemo\scripts\GameToolsParticleDemo.vcproj", "{03012D49-293B-4427-BC47-0B6061EF5543}"
+	ProjectSection(ProjectDependencies) = postProject
+		{EE2B2AE5-1057-4EE9-A7BB-E59FCF1D5FFB} = {EE2B2AE5-1057-4EE9-A7BB-E59FCF1D5FFB}
 		{109F610E-9B23-4D05-819E-A7F27A42AA94} = {109F610E-9B23-4D05-819E-A7F27A42AA94}
 	EndProjectSection
 EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "PRMDemo", "..\..\..\..\App\Demos\Illum\Ogre\src\PRMDemo\scripts\PRMDemo.vcproj", "{09F9E809-02CF-4926-8203-2B9C02FBD916}"
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "CausticTest", "..\..\..\..\App\Demos\Illum\Ogre\src\CausticTest\scripts\CausticTest.vcproj", "{B57DE690-046A-4015-AF46-93DE29C0F9AB}"
 	ProjectSection(ProjectDependencies) = postProject
-		{109F610E-9B23-4D05-819E-A7F27A42AA94} = {109F610E-9B23-4D05-819E-A7F27A42AA94}
-		{109F610E-9B23-4D05-819E-A7F27A42AA94} = {109F610E-9B23-4D05-819E-A7F27A42AA94}
+		{EE2B2AE5-1057-4EE9-A7BB-E59FCF1D5FFB} = {EE2B2AE5-1057-4EE9-A7BB-E59FCF1D5FFB}
 	EndProjectSection
 EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "GameToolsParticleDemo", "..\..\..\..\App\Demos\Illum\Ogre\src\GameToolsParticleDemo\scripts\GameToolsParticleDemo.vcproj", "{09F9E809-02CF-4926-8203-2B9C02FBD916}"
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "DiffuseTest", "..\..\..\..\App\Demos\Illum\Ogre\src\DiffuseTest\scripts\DiffuseTest.vcproj", "{12A26E3E-5B80-4B57-BFB7-63F0DADA78D0}"
 	ProjectSection(ProjectDependencies) = postProject
-		{109F610E-9B23-4D05-819E-A7F27A42AA94} = {109F610E-9B23-4D05-819E-A7F27A42AA94}
-		{109F610E-9B23-4D05-819E-A7F27A42AA94} = {109F610E-9B23-4D05-819E-A7F27A42AA94}
+		{EE2B2AE5-1057-4EE9-A7BB-E59FCF1D5FFB} = {EE2B2AE5-1057-4EE9-A7BB-E59FCF1D5FFB}
 	EndProjectSection
 EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "CausticTest", "..\..\..\..\App\Demos\Illum\Ogre\src\CausticTest\scripts\CausticTest.vcproj", "{09F9E809-02CF-4926-8203-2B9C02FBD916}"
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "ToneMapDemo", "..\..\..\..\App\Demos\Illum\Ogre\src\GameToolsToneMapDemo\scripts\GameToolsToneMapDemo.vcproj", "{A85ED551-C592-4D5C-A093-44CF6C6BDC75}"
 	ProjectSection(ProjectDependencies) = postProject
-	EndProjectSection
-EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "DiffuseTest", "..\..\..\..\App\Demos\Illum\Ogre\src\DiffuseTest\scripts\DiffuseTest.vcproj", "{09F9E809-02CF-4926-8203-2B9C02FBD916}"
-	ProjectSection(ProjectDependencies) = postProject
-	EndProjectSection
-EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "ToneMapDemo", "..\..\..\..\App\Demos\Illum\Ogre\src\GameToolsToneMapDemo\scripts\GameToolsToneMapDemo.vcproj", "{09F9E809-02CF-4926-8203-2B9C02FBD916}"
-	ProjectSection(ProjectDependencies) = postProject
+		{EE2B2AE5-1057-4EE9-A7BB-E59FCF1D5FFB} = {EE2B2AE5-1057-4EE9-A7BB-E59FCF1D5FFB}
 	EndProjectSection
 EndProject
 Global
-	GlobalSection(SolutionConfiguration) = preSolution
-		Debug = Debug
-		Release = Release
+	GlobalSection(SolutionConfigurationPlatforms) = preSolution
+		Debug|Win32 = Debug|Win32
+		Release|Win32 = Release|Win32
 	EndGlobalSection
-	GlobalSection(ProjectConfiguration) = postSolution
-		{109F610E-9B23-4D05-819E-A7F27A42AA94}.Debug.ActiveCfg = Debug|Win32
-		{109F610E-9B23-4D05-819E-A7F27A42AA94}.Debug.Build.0 = Debug|Win32
-		{109F610E-9B23-4D05-819E-A7F27A42AA94}.Release.ActiveCfg = Release|Win32
-		{109F610E-9B23-4D05-819E-A7F27A42AA94}.Release.Build.0 = Release|Win32
-		{109F610E-9B23-4D05-819E-A7F27A42AA94}.Debug.ActiveCfg = Debug|Win32
-		{109F610E-9B23-4D05-819E-A7F27A42AA94}.Debug.Build.0 = Debug|Win32
-		{109F610E-9B23-4D05-819E-A7F27A42AA94}.Release.ActiveCfg = Release|Win32
-		{109F610E-9B23-4D05-819E-A7F27A42AA94}.Release.Build.0 = Release|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.ActiveCfg = Debug|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.Build.0 = Debug|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.ActiveCfg = Release|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.Build.0 = Release|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.ActiveCfg = Debug|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.Build.0 = Debug|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.ActiveCfg = Release|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.Build.0 = Release|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.ActiveCfg = Debug|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.Build.0 = Debug|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.ActiveCfg = Release|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.Build.0 = Release|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.ActiveCfg = Debug|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.Build.0 = Debug|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.ActiveCfg = Release|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.Build.0 = Release|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.ActiveCfg = Debug|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.Build.0 = Debug|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.ActiveCfg = Release|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.Build.0 = Release|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.ActiveCfg = Debug|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.Build.0 = Debug|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.ActiveCfg = Release|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.Build.0 = Release|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.ActiveCfg = Debug|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.Build.0 = Debug|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.ActiveCfg = Release|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.Build.0 = Release|Win32
+	GlobalSection(ProjectConfigurationPlatforms) = postSolution
+		{109F610E-9B23-4D05-819E-A7F27A42AA94}.Debug|Win32.ActiveCfg = Debug|Win32
+		{109F610E-9B23-4D05-819E-A7F27A42AA94}.Debug|Win32.Build.0 = Debug|Win32
+		{109F610E-9B23-4D05-819E-A7F27A42AA94}.Release|Win32.ActiveCfg = Release|Win32
+		{109F610E-9B23-4D05-819E-A7F27A42AA94}.Release|Win32.Build.0 = Release|Win32
+		{EE2B2AE5-1057-4EE9-A7BB-E59FCF1D5FFB}.Debug|Win32.ActiveCfg = Debug|Win32
+		{EE2B2AE5-1057-4EE9-A7BB-E59FCF1D5FFB}.Release|Win32.ActiveCfg = Release|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug|Win32.ActiveCfg = Debug|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug|Win32.Build.0 = Debug|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release|Win32.ActiveCfg = Release|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release|Win32.Build.0 = Release|Win32
+		{550E3771-33C4-4994-B323-C2ABFB37FE9F}.Debug|Win32.ActiveCfg = Debug|Win32
+		{550E3771-33C4-4994-B323-C2ABFB37FE9F}.Release|Win32.ActiveCfg = Release|Win32
+		{7AD6CB59-C8DB-40DB-B0E3-A2B750EB0284}.Debug|Win32.ActiveCfg = Debug|Win32
+		{7AD6CB59-C8DB-40DB-B0E3-A2B750EB0284}.Release|Win32.ActiveCfg = Release|Win32
+		{03012D49-293B-4427-BC47-0B6061EF5543}.Debug|Win32.ActiveCfg = Debug|Win32
+		{03012D49-293B-4427-BC47-0B6061EF5543}.Release|Win32.ActiveCfg = Release|Win32
+		{B57DE690-046A-4015-AF46-93DE29C0F9AB}.Debug|Win32.ActiveCfg = Debug|Win32
+		{B57DE690-046A-4015-AF46-93DE29C0F9AB}.Release|Win32.ActiveCfg = Release|Win32
+		{12A26E3E-5B80-4B57-BFB7-63F0DADA78D0}.Debug|Win32.ActiveCfg = Debug|Win32
+		{12A26E3E-5B80-4B57-BFB7-63F0DADA78D0}.Release|Win32.ActiveCfg = Release|Win32
+		{A85ED551-C592-4D5C-A093-44CF6C6BDC75}.Debug|Win32.ActiveCfg = Debug|Win32
+		{A85ED551-C592-4D5C-A093-44CF6C6BDC75}.Release|Win32.ActiveCfg = Release|Win32
 	EndGlobalSection
-	GlobalSection(ExtensibilityGlobals) = postSolution
-	EndGlobalSection
-	GlobalSection(ExtensibilityAddIns) = postSolution
+	GlobalSection(SolutionProperties) = preSolution
+		HideSolutionNode = FALSE
 	EndGlobalSection
 EndGlobal