Index: /GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/scripts/OgreIllumModule.vcproj.7.10.old
===================================================================
--- /GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/scripts/OgreIllumModule.vcproj.7.10.old	(revision 1690)
+++ /GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/scripts/OgreIllumModule.vcproj.7.10.old	(revision 1690)
@@ -0,0 +1,394 @@
+<?xml version="1.0" encoding="windows-1250"?>
+<VisualStudioProject
+	ProjectType="Visual C++"
+	Version="7.10"
+	Name="IllumModule_Ogre"
+	ProjectGUID="{109F610E-9B23-4D05-819E-A7F27A42AA94}"
+	Keyword="Win32Proj">
+	<Platforms>
+		<Platform
+			Name="Win32"/>
+	</Platforms>
+	<Configurations>
+		<Configuration
+			Name="Debug|Win32"
+			OutputDirectory="..\bin\$(ConfigurationName)"
+			IntermediateDirectory="..\obj\$(ConfigurationName)"
+			ConfigurationType="4"
+			CharacterSet="2">
+			<Tool
+				Name="VCCLCompilerTool"
+				Optimization="0"
+				ImproveFloatingPointConsistency="TRUE"
+				AdditionalIncludeDirectories="&quot;$(OGRE_PATH)\Samples\Common\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;..\include;..\include\RenderingRuns;..\include\RenderTechniques;..\..\IllumModule\include;..\..\IllumModule\include\RenderingRuns;..\..\IllumModule\include\RenderTechniques;&quot;$(OGRE_PATH)\PlugIns\OctreeSceneManager\include\&quot;"
+				PreprocessorDefinitions="WIN32;_DEBUG;_WINDOWS;GAMETOOLS_ILLUMINATION_MODULE"
+				MinimalRebuild="TRUE"
+				BasicRuntimeChecks="3"
+				RuntimeLibrary="3"
+				EnableFunctionLevelLinking="TRUE"
+				RuntimeTypeInfo="TRUE"
+				UsePrecompiledHeader="0"
+				WarningLevel="3"
+				Detect64BitPortabilityProblems="TRUE"
+				DebugInformationFormat="4"/>
+			<Tool
+				Name="VCCustomBuildTool"/>
+			<Tool
+				Name="VCLibrarianTool"
+				AdditionalDependencies="IllumModule.lib OgreMain_d.lib Plugin_OctreeSceneManager.lib"
+				AdditionalLibraryDirectories="..\..\IllumModule\bin\Debug;&quot;$(OGRE_PATH)\OgreMain\lib\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\PlugIns\OctreeSceneManager\bin\$(ConfigurationName)&quot;"/>
+			<Tool
+				Name="VCMIDLTool"/>
+			<Tool
+				Name="VCPostBuildEventTool"/>
+			<Tool
+				Name="VCPreBuildEventTool"/>
+			<Tool
+				Name="VCPreLinkEventTool"/>
+			<Tool
+				Name="VCResourceCompilerTool"/>
+			<Tool
+				Name="VCWebServiceProxyGeneratorTool"/>
+			<Tool
+				Name="VCXMLDataGeneratorTool"/>
+			<Tool
+				Name="VCManagedWrapperGeneratorTool"/>
+			<Tool
+				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
+		</Configuration>
+		<Configuration
+			Name="Release|Win32"
+			OutputDirectory="..\bin\$(ConfigurationName)"
+			IntermediateDirectory="..\obj\$(ConfigurationName)"
+			ConfigurationType="4"
+			CharacterSet="2"
+			WholeProgramOptimization="TRUE">
+			<Tool
+				Name="VCCLCompilerTool"
+				Optimization="2"
+				GlobalOptimizations="TRUE"
+				InlineFunctionExpansion="1"
+				EnableIntrinsicFunctions="TRUE"
+				ImproveFloatingPointConsistency="TRUE"
+				FavorSizeOrSpeed="1"
+				OmitFramePointers="TRUE"
+				OptimizeForProcessor="2"
+				OptimizeForWindowsApplication="TRUE"
+				AdditionalIncludeDirectories="&quot;$(OGRE_PATH)\Samples\Common\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;..\include;..\include\RenderingRuns;..\include\RenderTechniques;..\..\IllumModule\include;..\..\IllumModule\include\RenderingRuns;..\..\IllumModule\include\RenderTechniques;&quot;$(OGRE_PATH)\PlugIns\OctreeSceneManager\include\&quot;"
+				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS;GAMETOOLS_ILLUMINATION_MODULE"
+				StringPooling="TRUE"
+				MinimalRebuild="TRUE"
+				RuntimeLibrary="2"
+				BufferSecurityCheck="FALSE"
+				EnableFunctionLevelLinking="TRUE"
+				RuntimeTypeInfo="TRUE"
+				UsePrecompiledHeader="0"
+				WarningLevel="3"
+				Detect64BitPortabilityProblems="TRUE"
+				DebugInformationFormat="3"/>
+			<Tool
+				Name="VCCustomBuildTool"/>
+			<Tool
+				Name="VCLibrarianTool"
+				AdditionalDependencies="IllumModule.lib OgreMain.lib Plugin_OctreeSceneManager.lib"
+				AdditionalLibraryDirectories="..\..\IllumModule\bin\Release;&quot;$(OGRE_PATH)\OgreMain\lib\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\PlugIns\OctreeSceneManager\bin\$(ConfigurationName)&quot;"/>
+			<Tool
+				Name="VCMIDLTool"/>
+			<Tool
+				Name="VCPostBuildEventTool"/>
+			<Tool
+				Name="VCPreBuildEventTool"/>
+			<Tool
+				Name="VCPreLinkEventTool"/>
+			<Tool
+				Name="VCResourceCompilerTool"/>
+			<Tool
+				Name="VCWebServiceProxyGeneratorTool"/>
+			<Tool
+				Name="VCXMLDataGeneratorTool"/>
+			<Tool
+				Name="VCManagedWrapperGeneratorTool"/>
+			<Tool
+				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
+		</Configuration>
+	</Configurations>
+	<References>
+	</References>
+	<Files>
+		<Filter
+			Name="Source Files"
+			Filter="cpp;c;cxx;def;odl;idl;hpj;bat;asm">
+			<File
+				RelativePath="..\src\OgreIlluminationManager.cpp">
+			</File>
+			<File
+				RelativePath="..\src\OgreRenderable.cpp">
+			</File>
+			<File
+				RelativePath="..\src\OgreRenderingRun.cpp">
+			</File>
+			<File
+				RelativePath="..\src\OgreRenderTechnique.cpp">
+			</File>
+			<File
+				RelativePath="..\src\OgreSharedRuns.cpp">
+			</File>
+			<File
+				RelativePath="..\src\OgreTechniqueGroup.cpp">
+			</File>
+			<Filter
+				Name="RenderTechniques"
+				Filter="">
+				<File
+					RelativePath="..\src\RenderTechniques\OgreCausticCasterRenderTechnique.cpp">
+				</File>
+				<File
+					RelativePath="..\src\RenderTechniques\OgreCausticRecieverRenderTechnique.cpp">
+				</File>
+				<File
+					RelativePath="..\src\RenderTechniques\OgreConvolvedCubeMapRenderTechnique.cpp">
+				</File>
+				<File
+					RelativePath="..\src\RenderTechniques\OgreCubeMapRenderTechnique.cpp">
+				</File>
+				<File
+					RelativePath="..\src\RenderTechniques\OgreDepthShadowRecieverRenderTechnique.cpp">
+				</File>
+				<File
+					RelativePath="..\src\RenderTechniques\OgreDistanceCubeMapRenderTechnique.cpp">
+				</File>
+				<File
+					RelativePath="..\src\RenderTechniques\OgreFireRenderTechnique.cpp">
+				</File>
+				<File
+					RelativePath="..\src\RenderTechniques\OgreHierarchicalParticleSystemTechnique.cpp">
+				</File>
+				<File
+					RelativePath="..\src\RenderTechniques\OgreIllumVolumeRenderTechnique.cpp">
+				</File>
+				<File
+					RelativePath="..\src\RenderTechniques\OgreSBBRenderTechnique.cpp">
+				</File>
+			</Filter>
+			<Filter
+				Name="RenderingRuns"
+				Filter="">
+				<File
+					RelativePath="..\src\RenderingRuns\OgreCausticCubeMapRenderingRun.cpp">
+				</File>
+				<File
+					RelativePath="..\src\RenderingRuns\OgreChildParticlesystemRenderingRun.cpp">
+				</File>
+				<File
+					RelativePath="..\src\RenderingRuns\OgreColorCubeMapRenderingRun.cpp">
+				</File>
+				<File
+					RelativePath="..\src\RenderingRuns\OgreDepthShadowMapRenderingRun.cpp">
+				</File>
+				<File
+					RelativePath="..\src\RenderingRuns\OgreDistanceCubeMapRenderingRun.cpp">
+				</File>
+				<File
+					RelativePath="..\src\RenderingRuns\OgreFocusingMapRenderingRun.cpp">
+				</File>
+				<File
+					RelativePath="..\src\RenderingRuns\OgreLightVolumeRenderingRun.cpp">
+				</File>
+				<File
+					RelativePath="..\src\RenderingRuns\OgrePhaseTextureRenderingRun.cpp">
+				</File>
+				<File
+					RelativePath="..\src\RenderingRuns\OgrePhotonMapRenderingRun.cpp">
+				</File>
+				<File
+					RelativePath="..\src\RenderingRuns\OgreReducedCubeMapRenderingRun.cpp">
+				</File>
+				<File
+					RelativePath="..\src\RenderingRuns\OgreSceneCameraDepthRenderingRun.cpp">
+				</File>
+			</Filter>
+		</Filter>
+		<Filter
+			Name="Resource Files"
+			Filter="rc;ico;cur;bmp;dlg;rc2;rct;bin;rgs;gif;jpg;jpeg;jpe">
+		</Filter>
+		<Filter
+			Name="Header Files"
+			Filter="h;hpp;hxx;hm;inl;inc">
+			<File
+				RelativePath="..\include\OgreIlluminationManager.h">
+			</File>
+			<File
+				RelativePath="..\include\OgreRenderable.h">
+			</File>
+			<File
+				RelativePath="..\include\OgreRenderingRun.h">
+			</File>
+			<File
+				RelativePath="..\include\OgreRenderTechnique.h">
+			</File>
+			<File
+				RelativePath="..\include\OgreSharedRuns.h">
+			</File>
+			<File
+				RelativePath="..\include\OgreTechniqueGroup.h">
+			</File>
+			<Filter
+				Name="RenderTechniques"
+				Filter="">
+				<File
+					RelativePath="..\include\RenderTechniques\OgreCausticCasterRenderTechnique.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderTechniques\OgreCausticRecieverRenderTechnique.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderTechniques\OgreConvolvedCubeMapRenderTechnique.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderTechniques\OgreCubeMapRenderTechnique.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderTechniques\OgreDepthShadowRecieverRenderTechnique.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderTechniques\OgreDistanceCubeMapRenderTechnique.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderTechniques\OgreFireRenderTechnique.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderTechniques\OgreHierarchicalParticleSystemTechnique.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderTechniques\OgreIllumVolumeRenderTechnique.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderTechniques\OgreSBBRenderTechnique.h">
+				</File>
+			</Filter>
+			<Filter
+				Name="RenderingRuns"
+				Filter="">
+				<File
+					RelativePath="..\include\RenderingRuns\OgreCausticCubeMapRenderingRun.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderingRuns\OgreChildPSystemRenderingRun.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderingRuns\OgreColorCubeMapRenderingRun.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderingRuns\OgreDepthShadowMapRenderingRun.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderingRuns\OgreDistanceCubeMapRenderingRun.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderingRuns\OgreFocusingMapRenderingRun.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderingRuns\OgreLightVolumeRenderingRun.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderingRuns\OgrePhaseTextureRenderingRun.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderingRuns\OgrePhotonMapRenderingRun.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderingRuns\OgreReducedCubeMapRenderingRun.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderingRuns\OgreSceneCameraDepthRenderingRun.h">
+				</File>
+			</Filter>
+		</Filter>
+		<Filter
+			Name="Media"
+			Filter="">
+			<Filter
+				Name="materials"
+				Filter="">
+				<File
+					RelativePath="..\..\..\..\..\App\Demos\Illum\Ogre\Media\materials\scripts\EnvMetals.material">
+				</File>
+				<File
+					RelativePath="..\..\..\..\..\App\Demos\Illum\Ogre\Media\materials\scripts\GameTools.material">
+				</File>
+				<File
+					RelativePath="..\..\..\..\..\App\Demos\Illum\Ogre\Media\materials\scripts\GameTools_Glow.compositor">
+				</File>
+				<File
+					RelativePath="..\..\..\..\..\App\Demos\Illum\Ogre\Media\materials\scripts\GameTools_ToneMap.compositor">
+				</File>
+				<File
+					RelativePath="..\..\..\..\..\App\Demos\Illum\Ogre\Media\materials\scripts\kupola.material">
+				</File>
+				<File
+					RelativePath="..\..\..\..\..\App\Demos\Illum\Ogre\Media\materials\scripts\Particles.material">
+				</File>
+			</Filter>
+			<Filter
+				Name="programs"
+				Filter="">
+				<File
+					RelativePath="..\..\..\..\..\App\Demos\Illum\Ogre\Media\materials\scripts\GameTools.program">
+				</File>
+			</Filter>
+			<Filter
+				Name="shaders"
+				Filter="">
+				<File
+					RelativePath="..\..\..\..\..\App\Demos\Illum\Ogre\Media\materials\programs\GameTools_Cau.hlsl">
+				</File>
+				<File
+					RelativePath="..\..\..\..\..\App\Demos\Illum\Ogre\Media\materials\programs\GameTools_Caustic.hlsl">
+				</File>
+				<File
+					RelativePath="..\..\..\..\..\App\Demos\Illum\Ogre\Media\materials\programs\GameTools_CausticSoftShadow.hlsl">
+				</File>
+				<File
+					RelativePath="..\..\..\..\..\App\Demos\Illum\Ogre\Media\materials\programs\GameTools_CubeMap.hlsl">
+				</File>
+				<File
+					RelativePath="..\..\..\..\..\App\Demos\Illum\Ogre\Media\materials\programs\GameTools_Depth.hlsl">
+				</File>
+				<File
+					RelativePath="..\..\..\..\..\App\Demos\Illum\Ogre\Media\materials\programs\GameTools_DepthShadow.hlsl">
+				</File>
+				<File
+					RelativePath="..\..\..\..\..\App\Demos\Illum\Ogre\Media\materials\programs\GameTools_Distance.hlsl">
+				</File>
+				<File
+					RelativePath="..\..\..\..\..\App\Demos\Illum\Ogre\Media\materials\programs\GameTools_Focusing.hlsl">
+				</File>
+				<File
+					RelativePath="..\..\..\..\..\App\Demos\Illum\Ogre\Media\materials\programs\GameTools_Localized_EnvMap.hlsl">
+				</File>
+				<File
+					RelativePath="..\..\..\..\..\App\Demos\Illum\Ogre\Media\materials\programs\GameTools_LocalizedBump_EnvMap.hlsl">
+				</File>
+				<File
+					RelativePath="..\..\..\..\..\App\Demos\Illum\Ogre\Media\materials\programs\GameTools_PostProc.hlsl">
+				</File>
+				<File
+					RelativePath="..\..\..\..\..\App\Demos\Illum\Ogre\Media\materials\programs\GameTools_ReduceCubeMap.hlsl">
+				</File>
+				<File
+					RelativePath="..\..\..\..\..\App\Demos\Illum\Ogre\Media\materials\programs\GameTools_Sprite.hlsl">
+				</File>
+				<File
+					RelativePath="..\..\..\..\..\App\Demos\Illum\Ogre\Media\materials\programs\GameTools_UV.hlsl">
+				</File>
+			</Filter>
+			<Filter
+				Name="particles"
+				Filter="">
+			</Filter>
+		</Filter>
+	</Files>
+	<Globals>
+	</Globals>
+</VisualStudioProject>
Index: /GTP/trunk/Lib/Illum/IllumModule/IllumModule/scripts/illummodule.vcproj.7.10.old
===================================================================
--- /GTP/trunk/Lib/Illum/IllumModule/IllumModule/scripts/illummodule.vcproj.7.10.old	(revision 1690)
+++ /GTP/trunk/Lib/Illum/IllumModule/IllumModule/scripts/illummodule.vcproj.7.10.old	(revision 1690)
@@ -0,0 +1,301 @@
+<?xml version="1.0" encoding="windows-1250"?>
+<VisualStudioProject
+	ProjectType="Visual C++"
+	Version="7.10"
+	Name="IllumModule"
+	ProjectGUID="{109F610E-9B23-4D05-819E-A7F27A42AA94}"
+	Keyword="Win32Proj">
+	<Platforms>
+		<Platform
+			Name="Win32"/>
+	</Platforms>
+	<Configurations>
+		<Configuration
+			Name="Debug|Win32"
+			OutputDirectory="..\bin\$(ConfigurationName)"
+			IntermediateDirectory="..\obj\$(ConfigurationName)"
+			ConfigurationType="4"
+			CharacterSet="2">
+			<Tool
+				Name="VCCLCompilerTool"
+				Optimization="0"
+				ImproveFloatingPointConsistency="TRUE"
+				AdditionalIncludeDirectories="..\include;..\include\RenderingRuns;..\include\RenderTechniques"
+				PreprocessorDefinitions="WIN32;_DEBUG;_WINDOWS"
+				MinimalRebuild="TRUE"
+				BasicRuntimeChecks="3"
+				RuntimeLibrary="3"
+				EnableFunctionLevelLinking="TRUE"
+				RuntimeTypeInfo="TRUE"
+				UsePrecompiledHeader="0"
+				WarningLevel="3"
+				Detect64BitPortabilityProblems="TRUE"
+				DebugInformationFormat="4"/>
+			<Tool
+				Name="VCCustomBuildTool"/>
+			<Tool
+				Name="VCLibrarianTool"/>
+			<Tool
+				Name="VCMIDLTool"/>
+			<Tool
+				Name="VCPostBuildEventTool"/>
+			<Tool
+				Name="VCPreBuildEventTool"/>
+			<Tool
+				Name="VCPreLinkEventTool"/>
+			<Tool
+				Name="VCResourceCompilerTool"/>
+			<Tool
+				Name="VCWebServiceProxyGeneratorTool"/>
+			<Tool
+				Name="VCXMLDataGeneratorTool"/>
+			<Tool
+				Name="VCManagedWrapperGeneratorTool"/>
+			<Tool
+				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
+		</Configuration>
+		<Configuration
+			Name="Release|Win32"
+			OutputDirectory="..\bin\$(ConfigurationName)"
+			IntermediateDirectory="..\obj\$(ConfigurationName)"
+			ConfigurationType="4"
+			CharacterSet="2"
+			WholeProgramOptimization="TRUE">
+			<Tool
+				Name="VCCLCompilerTool"
+				Optimization="2"
+				GlobalOptimizations="TRUE"
+				InlineFunctionExpansion="1"
+				EnableIntrinsicFunctions="TRUE"
+				ImproveFloatingPointConsistency="TRUE"
+				FavorSizeOrSpeed="1"
+				OmitFramePointers="TRUE"
+				OptimizeForProcessor="2"
+				OptimizeForWindowsApplication="TRUE"
+				AdditionalIncludeDirectories="..\include;..\include\RenderingRuns;..\include\RenderTechniques"
+				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS"
+				StringPooling="TRUE"
+				MinimalRebuild="TRUE"
+				RuntimeLibrary="2"
+				BufferSecurityCheck="FALSE"
+				EnableFunctionLevelLinking="TRUE"
+				RuntimeTypeInfo="TRUE"
+				UsePrecompiledHeader="0"
+				WarningLevel="3"
+				Detect64BitPortabilityProblems="TRUE"
+				DebugInformationFormat="3"/>
+			<Tool
+				Name="VCCustomBuildTool"/>
+			<Tool
+				Name="VCLibrarianTool"/>
+			<Tool
+				Name="VCMIDLTool"/>
+			<Tool
+				Name="VCPostBuildEventTool"/>
+			<Tool
+				Name="VCPreBuildEventTool"/>
+			<Tool
+				Name="VCPreLinkEventTool"/>
+			<Tool
+				Name="VCResourceCompilerTool"/>
+			<Tool
+				Name="VCWebServiceProxyGeneratorTool"/>
+			<Tool
+				Name="VCXMLDataGeneratorTool"/>
+			<Tool
+				Name="VCManagedWrapperGeneratorTool"/>
+			<Tool
+				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
+		</Configuration>
+	</Configurations>
+	<References>
+	</References>
+	<Files>
+		<Filter
+			Name="Source Files"
+			Filter="cpp;c;cxx;def;odl;idl;hpj;bat;asm">
+			<File
+				RelativePath="..\src\ElementaryRenderable.cpp">
+			</File>
+			<File
+				RelativePath="..\src\IlluminationManager.cpp">
+			</File>
+			<File
+				RelativePath="..\src\RenderingRun.cpp">
+			</File>
+			<File
+				RelativePath="..\src\RenderTechnique.cpp">
+			</File>
+			<File
+				RelativePath="..\src\SharedRuns.cpp">
+			</File>
+			<File
+				RelativePath="..\src\TechniqueGroup.cpp">
+			</File>
+			<Filter
+				Name="RenderTechniques"
+				Filter="">
+				<File
+					RelativePath="..\src\RenderTechniques\CausticCasterRenderTechnique.cpp">
+				</File>
+				<File
+					RelativePath="..\src\RenderTechniques\CausticRecieverRenderTechnique.cpp">
+				</File>
+				<File
+					RelativePath="..\src\RenderTechniques\ConvolvedCubeMapRenderTechnique.cpp">
+				</File>
+				<File
+					RelativePath="..\src\RenderTechniques\CubeMapRenderTechnique.cpp">
+				</File>
+				<File
+					RelativePath="..\src\RenderTechniques\DepthShadowRecieverRenderTechnique.cpp">
+				</File>
+				<File
+					RelativePath="..\src\RenderTechniques\DistanceCubeMapRenderTechnique.cpp">
+				</File>
+				<File
+					RelativePath="..\src\RenderTechniques\HierarchicalParticleSystemTechnique.cpp">
+				</File>
+				<File
+					RelativePath="..\src\RenderTechniques\IllumVolumeRenderTechnique.cpp">
+				</File>
+				<File
+					RelativePath="..\src\RenderTechniques\SBBRenderTechnique.cpp">
+				</File>
+			</Filter>
+			<Filter
+				Name="RenderingRuns"
+				Filter="">
+				<File
+					RelativePath="..\src\RenderingRuns\CausticCubeMapRenderingRun.cpp">
+				</File>
+				<File
+					RelativePath="..\src\RenderingRuns\ChildPSystemRenderingRun.cpp">
+				</File>
+				<File
+					RelativePath="..\src\RenderingRuns\ColorCubeMapRenderingRun.cpp">
+				</File>
+				<File
+					RelativePath="..\src\RenderingRuns\DepthShadowMapRenderingRun.cpp">
+				</File>
+				<File
+					RelativePath="..\src\RenderingRuns\DistanceCubeMapRenderingRun.cpp">
+				</File>
+				<File
+					RelativePath="..\src\RenderingRuns\LightVolumeRenderingRun.cpp">
+				</File>
+				<File
+					RelativePath="..\src\RenderingRuns\PhaseTextureRenderingRun.cpp">
+				</File>
+				<File
+					RelativePath="..\src\RenderingRuns\PhotonMapRenderingRun.cpp">
+				</File>
+				<File
+					RelativePath="..\src\RenderingRuns\ReducedCubeMapRenderingRun.cpp">
+				</File>
+				<File
+					RelativePath="..\src\RenderingRuns\SceneCameraDepthRenderingRun.cpp">
+				</File>
+			</Filter>
+		</Filter>
+		<Filter
+			Name="Header Files"
+			Filter="h;hpp;hxx;hm;inl;inc">
+			<File
+				RelativePath="..\include\ElementaryRenderable.h">
+			</File>
+			<File
+				RelativePath="..\include\IlluminationManager.h">
+			</File>
+			<File
+				RelativePath="..\include\RenderingRun.h">
+			</File>
+			<File
+				RelativePath="..\include\RenderTechnique.h">
+			</File>
+			<File
+				RelativePath="..\include\SharedRuns.h">
+			</File>
+			<File
+				RelativePath="..\include\TechniqueGroup.h">
+			</File>
+			<Filter
+				Name="RenderTechniques"
+				Filter="">
+				<File
+					RelativePath="..\include\RenderTechniques\CausticCasterRenderTechnique.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderTechniques\CausticRecieverRenderTechnique.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderTechniques\ConvolvedCubeMapRenderTechnique.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderTechniques\CubeMapRenderTechnique.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderTechniques\DepthShadowRecieverRenderTechnique.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderTechniques\DistanceCubeMapRenderTechnique.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderTechniques\HierarchicalParticleSystemTechnique.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderTechniques\IllumVolumeRenderTechnique.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderTechniques\SBBRenderTechnique.h">
+				</File>
+			</Filter>
+			<Filter
+				Name="RenderingRuns"
+				Filter="">
+				<File
+					RelativePath="..\include\RenderingRuns\CausticCubeMapRenderingRun.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderingRuns\ChildPSystemRenderingRun.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderingRuns\ColorCubeMapRenderingRun.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderingRuns\DepthShadowMapRenderingRun.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderingRuns\DistanceCubeMapRenderingRun.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderingRuns\LightVolumeRenderingRun.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderingRuns\PhaseTextureRenderingRun.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderingRuns\PhotonMapRenderingRun.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderingRuns\ReducedCubeMapRenderingRun.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderingRuns\SceneCameraDepthRenderingRun.h">
+				</File>
+			</Filter>
+			<Filter
+				Name="Resource Files"
+				Filter="rc;ico;cur;bmp;dlg;rc2;rct;bin;rgs;gif;jpg;jpeg;jpe">
+				<File
+					RelativePath="..\..\..\..\..\..\..\EGDemoGame\Media\materials\scripts\car.material">
+				</File>
+				<File
+					RelativePath="..\..\..\..\..\..\..\EGDemoGame\Media\materials\programs\CarReflections.hlsl">
+				</File>
+			</Filter>
+		</Filter>
+	</Files>
+	<Globals>
+	</Globals>
+</VisualStudioProject>